package com.gic.udesk.web.controller;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.ano.IgnoreLogin;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.udesk.constant.UdeskSharedConstant;
import com.gic.udesk.dto.UdeskMessageDTO;
import com.gic.udesk.service.TapdMessageApiService;
import com.gic.udesk.service.UdeskMessageApiService;

@RestController
public class MessageController {
    private static final Logger logger = LogManager.getLogger(MessageController.class);

    @Autowired
    private UdeskMessageApiService udeskMessageApiService;
    @Autowired
    private TapdMessageApiService tapdMessageApiService;

    @IgnoreLogin
    @RequestMapping("udesk-message")
    public RestResponse udeskMessage(@RequestBody UdeskMessageDTO udeskMessage) {
        logger.info("接收UDESK的消息是：{}", udeskMessage);
        udeskMessage.setSource(UdeskSharedConstant.UDESK_SOURCE);
        return ResultControllerUtils.commonResult(udeskMessageApiService.saveUdeskMessage(udeskMessage));
    }

    @RequestMapping(value = "tapd-message", method = RequestMethod.POST)
    @IgnoreLogin
    public RestResponse tapdMessage(@RequestBody String tapdMessageStr) {
        logger.info("接收TAPD的消息:{}",tapdMessageStr);
        return ResultControllerUtils.commonResult(tapdMessageApiService.handleTapdMessage(tapdMessageStr));
    }
}
